"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FormFieldSkin = FormFieldSkin;

var _react = _interopRequireDefault(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _PopOver = require("../../components/PopOver");

var _SimpleFormField = require("../../themes/simple/SimpleFormField");

var _hooks = _interopRequireDefault(require("../../utils/hooks"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function FormFieldSkin(props) {
  var hasErrorChanged = (0, _hooks["default"])(props.error, props.errorDebounceDelay);
  var hasError = hasErrorChanged && props.error != null;
  return (
    /*#__PURE__*/
    _react["default"].createElement("div", {
      className: (0, _classnames["default"])([props.className, props.theme[props.themeId].root, props.disabled ? props.theme[props.themeId].disabled : null, props.error ? props.theme[props.themeId].errored : null])
    }, props.label &&
    /*#__PURE__*/
    _react["default"].createElement("label", {
      role: "presentation",
      "aria-hidden": true,
      className: props.theme[props.themeId].label,
      onClick: props.focusChild
    }, props.label),
    /*#__PURE__*/
    _react["default"].createElement(_PopOver.PopOver, {
      isShowingOnHover: hasError,
      isVisible: hasError && props.hasFocus,
      content: props.error,
      themeVariables: {
        '--rp-pop-over-bg-color': "var(".concat(_SimpleFormField.SimpleFormFieldVariables.errorColor)
      },
      placement: "bottom",
      popperOptions: {
        modifiers: [{
          name: 'flip',
          enabled: false
        }]
      },
      duration: [300, 0]
    },
    /*#__PURE__*/
    _react["default"].createElement("div", {
      className: props.theme[props.themeId].inputWrapper
    }, props.render())))
  );
}
//# sourceMappingURL=FormFieldSkin.js.map