"use strict";

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.InputSkin = void 0;

var _isFunction2 = _interopRequireDefault(require("lodash/isFunction"));

var _react = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _FormField = require("../../components/FormField");

var _props = require("../../utils/props");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var InputSkin = function InputSkin(props) {
  var _useState = (0, _react.useState)(false),
      _useState2 = _slicedToArray(_useState, 2),
      hasInputFocus = _useState2[0],
      setHasInputFocus = _useState2[1];

  var renderInput = function renderInput() {
    return (
      /*#__PURE__*/
      _react["default"].createElement("input", _extends({
        ref: props.inputRef
      }, (0, _props.pickDOMProps)(props), {
        onBlur: function onBlur(event) {
          var _props$onBlur;

          setHasInputFocus(false);
          (_props$onBlur = props.onBlur) === null || _props$onBlur === void 0 ? void 0 : _props$onBlur.call(props, event);
        },
        onFocus: function onFocus(event) {
          var _props$onFocus;

          setHasInputFocus(true);
          (_props$onFocus = props.onFocus) === null || _props$onFocus === void 0 ? void 0 : _props$onFocus.call(props, event);
        },
        className: (0, _classnames["default"])([props.theme[props.themeId].input, props.disabled ? props.theme[props.themeId].disabled : null, props.error || props.showErrorState ? props.theme[props.themeId].errored : null]),
        readOnly: props.readOnly
      }))
    );
  };

  var useSelectionRenderer = function useSelectionRenderer(option) {
    return (
      /*#__PURE__*/
      _react["default"].createElement("div", {
        className: props.theme[props.themeId].customValueWrapper
      }, renderInput(),
      /*#__PURE__*/
      _react["default"].createElement("div", {
        className: props.theme[props.themeId].customValueBlock
      }, option && props.selectionRenderer && props.selectionRenderer(option)))
    );
  };

  var render = function render() {
    // check if user has passed render prop "selectionRenderer"
    var hasSelectionRenderer = props.selectionRenderer && (0, _isFunction2["default"])(props.selectionRenderer);

    if (hasSelectionRenderer) {
      return useSelectionRenderer(props.selectedOption);
    }

    return renderInput();
  };

  return (
    /*#__PURE__*/
    _react["default"].createElement(_FormField.FormField, {
      className: props.className,
      disabled: props.disabled,
      label: props.label,
      hasFocus: hasInputFocus,
      error: props.error,
      inputRef: props.inputRef,
      theme: props.theme,
      render: render
    })
  );
};

exports.InputSkin = InputSkin;
//# sourceMappingURL=InputSkin.js.map